package cs451.net.handler;

import cs451.net.event.NetEvent;
import cs451.parser.Host;
import cs451.parser.Parser;

import java.util.List;

public class NetHandlerBEB extends NetEventHandler {

    private List<Host> hosts;
    private Host h;

    public NetHandlerBEB(Class<? extends NetEventHandler> deliverLayer, Class<? extends NetEventHandler> broadcastLayer) {
        super(deliverLayer,broadcastLayer);
    }


    @Override
    public void send(NetEvent ne) {
        for(Host h : hosts){
            if(this.h.getId() != h.getId()) {
                sendNext(NetEvent.Message(h, ne.message));
            }else{
                deliverNext(NetEvent.Message(h,ne.message));
            }
        }
    }

    @Override
    public void deliver(NetEvent ne) {
        deliverNext(ne);
    }

    public void start(Host h, Parser p) {
        this.h = h;
        hosts = p.hosts();
    }

}
