package cs451.net.handler;

import cs451.net.event.*;
import cs451.tools.Pair;

import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;


public class NetHandlerPL extends NetEventHandler {

    private final Set<Pair<Integer,Message>> delivered = ConcurrentHashMap.newKeySet();

    public NetHandlerPL(Class<? extends NetEventHandler> deliverLayer, Class<? extends NetEventHandler> broadcastLayer) {
        super(deliverLayer,broadcastLayer);
    }

    @Override
    public void send(NetEvent event) {
        sendNext(event);
    }

    @Override
    public void deliver(NetEvent event) {
        if(delivered.add(new Pair<>(event.peer.getId(),event.message))){
            deliverNext(event);
        }
    }

}
