package cs451.tools;

import java.util.ArrayList;
import java.util.List;

public class Pair<S, T> implements  Comparable {
    private final S x;
    private final T y;
    private final List<Object> vl = new ArrayList<>();

    public Pair(S x, T y) {
        this.x = x;
        this.y = y;
        vl.add(x.toString());
        vl.add(y.toString());
    }

    public S first(){
        return this.x;
    }

    public T second(){
        return this.y;
    }


    @Override
    public final String toString() {
        return this.vl.toString();
    }

    @Override
    public int hashCode() {
        return this.vl.hashCode();
    }

    @Override
    public final boolean equals(final Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Pair other = (Pair) obj;
        return this.vl.equals(other.vl);
    }

    @Override
    public int compareTo(Object o) {
        Pair co = (Pair)o;

        return ((int)co.second())- ((int)second());
    }
}
